Index: /trunk/src/org/apollo/widgets/SampleRecorder.java
===================================================================
--- /trunk/src/org/apollo/widgets/SampleRecorder.java	(revision 1101)
+++ /trunk/src/org/apollo/widgets/SampleRecorder.java	(revision 1102)
@@ -1,5 +1,4 @@
 package org.apollo.widgets;
 
-import java.awt.Color;
 import java.awt.Dimension;
 import java.awt.FontMetrics;
@@ -49,11 +48,13 @@
 import org.apollo.util.ApolloSystemLog;
 import org.apollo.util.TrackNameCreator;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Colour;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gio.swing.SwingConversions;
+import org.expeditee.gio.swing.SwingMiscManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.items.ItemParentStateChangedEvent;
 import org.expeditee.items.Text;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.SwingWidget;
 
 /**
@@ -63,6 +64,5 @@
  *
  */
-public class SampleRecorder extends InteractiveWidget 
-	implements ActionListener, Observer, MultitrackLoadListener {
+public class SampleRecorder extends SwingWidget implements ActionListener, Observer, MultitrackLoadListener {
 	
 	private enum WidgetState {
@@ -105,6 +105,6 @@
 	private final static int MAX_COUNTDOWN_TIME = 60;
 	
-	private static final Color GRAPH_BACKCOLOR = Color.BLACK;
-	private static final Color GRAPH_WAVECOLOR = Color.GREEN;
+	private static final Colour GRAPH_BACKCOLOR = Colour.BLACK;
+	private static final Colour GRAPH_WAVECOLOR = Colour.GREEN;
 	
 	private final static int RENDER_POINTS_PER_SECOND = 20; // how many points to render each second
@@ -112,9 +112,11 @@
 	private final static String COUNTDOWN_META = "countdown=";
 	
-	public SampleRecorder(Text source, String[] args) {
+	public SampleRecorder(Text source, String[] args)
+	{
 		this(source, args, false);
 	}
 	
-	public SampleRecorder(Text source, String[] args, boolean isTemporary) {
+	public SampleRecorder(Text source, String[] args, boolean isTemporary)
+	{
 		super(source, new JPanel(new GridBagLayout()),
 				AnimatedSampleGraph.GRAPH_WIDTH + (2 * HORO_SPACING), 
@@ -132,15 +134,15 @@
 		// Create gui layout
 		recordButton = new JButton();
-		recordButton.setIcon(IconRepository.getIcon("record.png"));
+		SwingMiscManager.setJButtonIcon(recordButton, IconRepository.getIcon("record.png"));
 		recordButton.addActionListener(this);
 		recordButton.setPreferredSize(new Dimension(AnimatedSampleGraph.GRAPH_WIDTH / 2, BUTTON_HEIGHT));
 		
 		recordSynchedButton = new JButton();
-		recordSynchedButton.setIcon(IconRepository.getIcon("recordplay.png"));
+		SwingMiscManager.setJButtonIcon(recordSynchedButton, IconRepository.getIcon("recordplay.png"));
 		recordSynchedButton.addActionListener(this);
 		recordSynchedButton.setPreferredSize(new Dimension(AnimatedSampleGraph.GRAPH_WIDTH / 2, BUTTON_HEIGHT));
 
 		stopButton = new JButton();
-		stopButton.setIcon(IconRepository.getIcon("stop.png"));
+		SwingMiscManager.setJButtonIcon(stopButton, IconRepository.getIcon("stop.png"));
 		stopButton.addActionListener(this);
 		stopButton.setPreferredSize(new Dimension(AnimatedSampleGraph.GRAPH_WIDTH, BUTTON_HEIGHT));
@@ -303,7 +305,7 @@
 	
 				sampleGraph.alternateText = Integer.toString(countDown);
-				sampleGraph.alternateTextColor = (countDown > 3) ? Color.WHITE : Color.RED;
+				sampleGraph.alternateTextColor = (countDown > 3) ? Colour.WHITE : Colour.RED;
 				sampleGraph.invalidateGraph();
-				FrameGraphics.refresh(true);
+				DisplayController.requestRefresh(true);
 				
 				countdownThread = new CountDownTimer(countDown);
@@ -373,5 +375,5 @@
 					 Frame targetFrame = getParentFrame();
 					 if (targetFrame == null) {
-						 targetFrame = DisplayIO.getCurrentFrame();
+						 targetFrame = DisplayController.getCurrentFrame();
 					 }
 					 
@@ -398,5 +400,5 @@
 					 } else {
 						 
-						 FrameMouseActions.pickup(trackWidget.getItems());
+						 StandardGestureActions.pickup(trackWidget.getItems());
 							
 						// Reset the state
@@ -602,5 +604,5 @@
 			assert (state == WidgetState.Ready);
 			
-			Frame target = DisplayIO.getCurrentFrame();
+			Frame target = DisplayController.getCurrentFrame();
 			if (target  == null) return;
 
@@ -608,8 +610,8 @@
 			
 			RecordOverdubLauncher launcher = new RecordOverdubLauncher((Integer)countDownSpinner.getValue());
-			launcher.setPosition(FrameMouseActions.MouseX, FrameMouseActions.MouseY);
+			launcher.setPosition(DisplayController.getMousePosition());
 
 			// Pick it up
-			FrameMouseActions.pickup(launcher);
+			StandardGestureActions.pickup(launcher);
 			
 		}
@@ -757,5 +759,5 @@
 			setState(WidgetState.LoadingPlayback, "Loading tracks...");
 			
-			Frame currentFrame = DisplayIO.getCurrentFrame();
+			Frame currentFrame = DisplayController.getCurrentFrame();
 			if (currentFrame == null || currentFrame.getName() == null) {
 				
@@ -843,10 +845,10 @@
 		
 		private String alternateText = null;
-		private Color alternateTextColor = Color.WHITE;
+		private Colour alternateTextColor = Colour.WHITE;
 
 		AnimatedSampleGraph() {
 			imageBuffer = new BufferedImage(GRAPH_WIDTH, GRAPH_HEIGHT, BufferedImage.TYPE_INT_RGB);
 			imageGraphics = (Graphics2D)imageBuffer.getGraphics();
-			imageGraphics.setColor(GRAPH_BACKCOLOR);
+			imageGraphics.setColor(SwingConversions.toSwingColor(GRAPH_BACKCOLOR));
 			imageGraphics.fillRect(0, 0, GRAPH_WIDTH, GRAPH_HEIGHT);
 			setPreferredSize(new Dimension(GRAPH_WIDTH, GRAPH_HEIGHT));
@@ -857,5 +859,5 @@
 		 */
 		public void clear() {
-			imageGraphics.setColor(GRAPH_BACKCOLOR);
+			imageGraphics.setColor(SwingConversions.toSwingColor(GRAPH_BACKCOLOR));
 			imageGraphics.fillRect(0, 0, GRAPH_WIDTH, GRAPH_HEIGHT);
 			invalidateGraph();
@@ -867,12 +869,12 @@
 			if (alternateText != null) {
 				
-				g.setColor(Color.BLACK);
+				g.setColor(SwingConversions.toSwingColor(Colour.BLACK));
 				g.fillRect(0, 0, getWidth(), getHeight());
 				
-				g.setFont(TrackWidgetCommons.FREESPACE_TRACKNAME_FONT);
-				g.setColor(alternateTextColor);
+				g.setFont(SwingMiscManager.getIfUsingSwingFontManager().getInternalFont(TrackWidgetCommons.FREESPACE_TRACKNAME_FONT));
+				g.setColor(SwingConversions.toSwingColor(alternateTextColor));
 				
 				// Center track name
-				FontMetrics fm   = g.getFontMetrics(TrackWidgetCommons.FREESPACE_TRACKNAME_FONT);
+				FontMetrics fm   = g.getFontMetrics(SwingMiscManager.getIfUsingSwingFontManager().getInternalFont(TrackWidgetCommons.FREESPACE_TRACKNAME_FONT));
 				Rectangle2D rect = fm.getStringBounds(alternateText, g);
 				
@@ -907,9 +909,9 @@
 			
 			// Render backcolor
-			imageGraphics.setColor(GRAPH_BACKCOLOR);
+			imageGraphics.setColor(SwingConversions.toSwingColor(GRAPH_BACKCOLOR));
 			imageGraphics.fillRect(GRAPH_WIDTH - pixelWidth, 0, pixelWidth, GRAPH_HEIGHT);
 			
 			// Render wave forms from lastSampleHeight
-			imageGraphics.setColor(GRAPH_WAVECOLOR);
+			imageGraphics.setColor(SwingConversions.toSwingColor(GRAPH_WAVECOLOR));
 			int currentPixelX = GRAPH_WIDTH - pixelWidth;
 
@@ -933,6 +935,6 @@
 	        Rectangle dirty = this.getBounds();
 	        dirty.translate(SampleRecorder.this.getX(), SampleRecorder.this.getY());
-	        FrameGraphics.invalidateArea(dirty); 
-	        FrameGraphics.refresh(true); 
+	        DisplayController.invalidateArea(SwingConversions.fromSwingRectangle(dirty)); 
+	        DisplayController.requestRefresh(true); 
 	        
 		}
@@ -979,7 +981,7 @@
 							sampleGraph.alternateText = Integer.toString(currentCountdown);
 							sampleGraph.alternateTextColor = (currentCountdown > 3) ?
-										Color.WHITE : Color.RED;
+										Colour.WHITE : Colour.RED;
 							sampleGraph.invalidateGraph();
-							FrameGraphics.refresh(true);
+							DisplayController.requestRefresh(true);
 						}
 					});
Index: /trunk/src/org/apollo/widgets/SampledTrack.java
===================================================================
--- /trunk/src/org/apollo/widgets/SampledTrack.java	(revision 1101)
+++ /trunk/src/org/apollo/widgets/SampledTrack.java	(revision 1102)
@@ -5,8 +5,6 @@
 import java.awt.Graphics;
 import java.awt.Graphics2D;
-import java.awt.Point;
 import java.awt.Rectangle;
 import java.awt.Shape;
-import java.awt.Stroke;
 import java.awt.event.ActionEvent;
 import java.awt.event.KeyEvent;
@@ -27,6 +25,6 @@
 import javax.swing.SwingUtilities;
 
-import org.apollo.AudioFrameKeyboardActions;
-import org.apollo.AudioFrameMouseActions;
+import org.apollo.ApolloGestureActions;
+import org.apollo.ApolloKBMGestureTranslator;
 import org.apollo.audio.ApolloPlaybackMixer;
 import org.apollo.audio.ApolloSubjectChangedEvent;
@@ -56,15 +54,19 @@
 import org.apollo.util.AudioMath;
 import org.apollo.util.Mutable;
-import org.apollo.util.PopupReaper;
 import org.apollo.util.TrackModelHandler;
 import org.apollo.util.TrackModelLoadManager;
 import org.apollo.util.TrackNameCreator;
-import org.expeditee.gui.Browser;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.Util;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Point;
+import org.expeditee.core.Stroke;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gio.swing.MouseEventRouter;
+import org.expeditee.gio.swing.SwingConversions;
+import org.expeditee.gio.swing.SwingMiscManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameMouseActions;
-import org.expeditee.gui.MouseEventRouter;
 import org.expeditee.gui.PopupManager;
 import org.expeditee.items.ItemParentStateChangedEvent;
@@ -72,7 +74,7 @@
 import org.expeditee.items.Text;
 import org.expeditee.items.widgets.HeavyDutyInteractiveWidget;
-import org.expeditee.items.widgets.InteractiveWidget;
 import org.expeditee.items.widgets.InteractiveWidgetInitialisationFailedException;
 import org.expeditee.items.widgets.InteractiveWidgetNotAvailableException;
+import org.expeditee.items.widgets.Widget;
 
 /**
@@ -82,6 +84,5 @@
  *
  */
-public class SampledTrack extends HeavyDutyInteractiveWidget 
-	implements TrackModelHandler, EffecientInvalidator, Observer {
+public class SampledTrack extends HeavyDutyInteractiveWidget implements TrackModelHandler, EffecientInvalidator, Observer {
 
 	/** The observered subject. Can be null */
@@ -115,7 +116,7 @@
 	private static final Stroke FREESPACE_OUTLINING = Strokes.SOLID_2;
 	
-	private static final Color SEMI_TRANSPARENT_FREESPACE_BACKCOLOR = new Color(
+	private static final Colour SEMI_TRANSPARENT_FREESPACE_BACKCOLOR = new Colour(
 			FREESPACE_BACKCOLOR.getRed(), FREESPACE_BACKCOLOR.getGreen(),
-			FREESPACE_BACKCOLOR.getBlue(), 128);
+			FREESPACE_BACKCOLOR.getBlue(), Colour.FromComponent255(128));
 	
 	
@@ -173,4 +174,10 @@
 		initObservers();
 		
+	}
+	
+	@Override
+	public void onMoved()
+	{
+		if (nameLabel != null) nameLabel.setPosition(new Point(getX() + 10, getY() + 20));
 	}
 
@@ -279,5 +286,5 @@
 
 				if (nameLabel != null) {
-					nameLabel.onMouseMoved(e, fulltrackView);
+					nameLabel.gainFocus();
 				}
 				
@@ -291,5 +298,5 @@
 					
 					// Get rid of all popups
-					PopupManager.getInstance().hideAutohidePopups();
+					PopupManager.getInstance().hideAutoHidePopups();
 					
 					Rectangle animationSource = _swingComponent.getBounds();
@@ -297,9 +304,9 @@
 					// Determine where popup should show
 					int x = SampledTrack.this.getX();
-					int y = SampledTrack.this.getY() - playbackControlPopup.getHeight() - 2; // by default show above
+					int y = SampledTrack.this.getY() - playbackControlPopup.getFullBounds().getHeight() - 2; // by default show above
 					
 					// I get sick.dizzy from the popup expanding from the whole thing...
 					animationSource.height = 1;
-					animationSource.width = Math.min(animationSource.width, playbackControlPopup.getWidth());
+					animationSource.width = Math.min(animationSource.width, playbackControlPopup.getFullBounds().getWidth());
 					
 					if (y < 0) {
@@ -309,21 +316,9 @@
 
 					// Animate the popup
-					PopupManager.getInstance().showPopup(
-							playbackControlPopup, 
-							new Point(x, y), 
-							fulltrackView,
-							PopupManager.getInstance().new ExpandShrinkAnimator(
-									animationSource,
-									Color.LIGHT_GRAY));
-					
-					PopupReaper.getInstance().initPopupLifetime(
-							playbackControlPopup, 
-							PopupManager.getInstance().new ExpandShrinkAnimator(
-									animationSource,
-									Color.LIGHT_GRAY), 
-									TrackWidgetCommons.POPUP_LIFETIME);
-					
+					playbackControlPopup.getAutoHideTime().setLifetime(TrackWidgetCommons.POPUP_LIFETIME);
+					PopupManager.getInstance().add(playbackControlPopup);
+					playbackControlPopup.show();
 				} else {
-					PopupReaper.getInstance().revivePopup(playbackControlPopup, TrackWidgetCommons.POPUP_LIFETIME);
+					playbackControlPopup.show();
 				}
 				
@@ -398,23 +393,14 @@
 		fulltrackView.addKeyListener(new KeyListener() {
 
-			public void keyPressed(KeyEvent e) {
-				if (!e.isControlDown() && nameLabel != null) {
-					if (nameLabel.onKeyPressed(e, fulltrackView)) {
-						e.consume();
-					}
-				}
-			}
-
-			public void keyReleased(KeyEvent e) {
-				if (!e.isControlDown() && nameLabel != null) {
-					if (nameLabel.onKeyReleased(e, fulltrackView)) {
-						e.consume();
-					}
-				}
-				
+			public void keyPressed(KeyEvent e)
+			{
+			}
+
+			public void keyReleased(KeyEvent e)
+			{
 				// Toggle pitch-track indexing
 				if (e.isControlDown() && e.getKeyCode() == KeyEvent.VK_I) {
 					setShouldOmitIndexAudio(!shouldOmitIndexAudio());
-					FrameGraphics.refresh(true);
+					DisplayController.requestRefresh(true);
 				}
 				
@@ -429,5 +415,5 @@
 				else if (e.isControlDown() && e.getKeyCode() == KeyEvent.VK_L) {
 
-					Frame current = DisplayIO.getCurrentFrame();
+					Frame current = DisplayController.getCurrentFrame();
 					
 					if (current != null) {
@@ -473,12 +459,18 @@
 					}
 	
-				} else if (e.isControlDown() && 
-						(e.getKeyCode() == KeyEvent.VK_LEFT || e.getKeyCode() == KeyEvent.VK_RIGHT)) {
-					e.consume();
-					AudioFrameKeyboardActions.adjustInitationTime(SampledTrack.this, e.getKeyCode() == KeyEvent.VK_LEFT);
-				} else if (e.isControlDown() && 
-						(e.getKeyCode() == KeyEvent.VK_UP || e.getKeyCode() == KeyEvent.VK_DOWN)) {
-					e.consume();
-					AudioFrameKeyboardActions.adjustVerticlePosition(SampledTrack.this, e.getKeyCode() == KeyEvent.VK_UP);
+				} else if (e.isControlDown()) {
+					if (e.getKeyCode() == KeyEvent.VK_LEFT) {
+						e.consume();
+						ApolloGestureActions.adjustInitiationTime(SampledTrack.this, -ApolloKBMGestureTranslator.TRACK_WIDGET_TIMELINE_ADJUSTMENT);
+					} else if (e.getKeyCode() == KeyEvent.VK_RIGHT) {
+						e.consume();
+						ApolloGestureActions.adjustInitiationTime(SampledTrack.this, ApolloKBMGestureTranslator.TRACK_WIDGET_TIMELINE_ADJUSTMENT);
+					} else if (e.getKeyCode() == KeyEvent.VK_UP) {
+						e.consume();
+						ApolloGestureActions.adjustVerticalPosition(SampledTrack.this, -ApolloKBMGestureTranslator.TRACK_WIDGET_VERTICAL_ADJUSTMENT);
+					} else if (e.getKeyCode() == KeyEvent.VK_DOWN) {
+						e.consume();
+						ApolloGestureActions.adjustVerticalPosition(SampledTrack.this, ApolloKBMGestureTranslator.TRACK_WIDGET_VERTICAL_ADJUSTMENT);
+					}
 				}
 
@@ -490,8 +482,6 @@
 		});
 		
-		
-		
-		nameLabel = new EmulatedTextItem(_swingComponent, new Point(10, 20));
-		nameLabel.setBackgroundColor(Color.WHITE);	
+		nameLabel = new EmulatedTextItem("", (new Point(10, 20)).add(getBounds().getTopLeft()));
+		nameLabel.setBackgroundColor(Colour.WHITE);	
 		
 		String metaName = getStrippedDataString(TrackWidgetCommons.META_NAME_TAG);
@@ -616,5 +606,5 @@
 		Text source = new Text(
 				targetFrame.getNextItemID(),
-				ItemUtils.GetTag(ItemUtils.TAG_IWIDGET) + ":" + formatArgs(args));
+				ItemUtils.GetTag(ItemUtils.TAG_IWIDGET) + ":" + Util.formatArgs(args));
 		
 		source.setParent(targetFrame);
@@ -685,5 +675,5 @@
 	
 	@Override
-	public InteractiveWidget copy() 
+	public Widget copy() 
 		throws InteractiveWidgetNotAvailableException, InteractiveWidgetInitialisationFailedException {
 		
@@ -1119,8 +1109,9 @@
 	}
 
-	public void onGraphDirty(SampledTrackGraphView graph, Rectangle dirty) {
+	public void onGraphDirty(SampledTrackGraphView graph, Rectangle dirty)
+	{
         dirty.translate(getX(), getY() - 1);
-        FrameGraphics.invalidateArea(dirty); 
-        FrameGraphics.refresh(true);
+        DisplayController.invalidateArea(SwingConversions.fromSwingRectangle(dirty)); 
+        DisplayController.requestRefresh(true);
 	}
 
@@ -1131,5 +1122,6 @@
 
 	@Override
-	protected void onSizeChanged() {
+	protected void onSizeChanged()
+	{
 		super.onSizeChanged();
 		// Keep meta as constant as possible for best reults
@@ -1246,9 +1238,12 @@
 
 	@Override
-	public void paintInFreeSpace(Graphics g) {
-		paintInFreeSpace(g, false);
-	}
-	
-	public void paintInFreeSpace(Graphics g, boolean isAtFinalPass) { 
+	public void paintInFreeSpace()
+	{
+		paintInFreeSpace(false);
+	}
+	
+	public void paintInFreeSpace(boolean isAtFinalPass)
+	{
+		Graphics g = SwingMiscManager.getIfUsingSwingGraphicsManager().getCurrentSurface();
 
 		if (isLoaded()) { 
@@ -1270,11 +1265,11 @@
 					
 
-					Point containerPoint = SwingUtilities.convertPoint(me.getComponent(), 
-							new Point(0,0), Browser._theBrowser.getContentPane());
+					Point containerPoint = SwingConversions.fromSwingPoint(SwingUtilities.convertPoint(me.getComponent(), 
+							new java.awt.Point(0,0), SwingMiscManager.getIfUsingSwingGraphicsManager().getContentPane()));
 					
 					Shape clipBackUp = g.getClip();
 					g.setClip(null);
 					
-					g.setColor(Color.ORANGE);
+					g.setColor(SwingConversions.toSwingColor(Colour.ORANGE));
 					((Graphics2D)g).setStroke(EditableSampledTrackGraphView.GRAPH_BAR_STROKE);
 					g.drawLine(
@@ -1284,5 +1279,5 @@
 							containerPoint.y + me.getComponent().getHeight());
 					
-					FrameGraphics.invalidateArea(new Rectangle(
+					DisplayController.invalidateArea(new AxisAlignedBoxBounds(
 							containerPoint.x + me.getX(), 
 							containerPoint.y, 
@@ -1293,10 +1288,10 @@
 					g.setClip(clipBackUp);
 					
-					g.setColor(SEMI_TRANSPARENT_FREESPACE_BACKCOLOR);
+					g.setColor(SwingConversions.toSwingColor(SEMI_TRANSPARENT_FREESPACE_BACKCOLOR));
 					g.fillRect(getX(), getY(), getWidth(), getHeight());
 					
 					if (isAtFinalPass) { // final pass does not draw the borders... so must manually draw them
-						g.setColor(Color.BLACK);
-						((Graphics2D)g).setStroke(FREESPACE_OUTLINING);
+						g.setColor(SwingConversions.toSwingColor(Colour.BLACK));
+						((Graphics2D)g).setStroke(SwingConversions.toSwingStroke(FREESPACE_OUTLINING));
 						g.drawRect(getX(), getY(), getWidth(), getHeight());
 					}
@@ -1311,5 +1306,5 @@
 		}
 		
-		super.paintInFreeSpace(g);
+		super.paintInFreeSpace();
 		
 		if (isLoaded()) {
@@ -1318,8 +1313,8 @@
 			Rectangle tmpClip = (clipBackUp != null) ? clipBackUp.getBounds() : 
 				new Rectangle(0, 0, 
-						Browser._theBrowser.getContentPane().getWidth(), 
-						Browser._theBrowser.getContentPane().getHeight());
-				
-			g.setClip(tmpClip.intersection(getBounds()));
+						SwingMiscManager.getIfUsingSwingGraphicsManager().getContentPane().getWidth(), 
+						SwingMiscManager.getIfUsingSwingGraphicsManager().getContentPane().getHeight());
+				
+			g.setClip(tmpClip.intersection(SwingConversions.toSwingRectangle(getBounds())));
 		
 			// Draw the name
@@ -1327,9 +1322,9 @@
 			if (name == null) name = "Unnamed";
 
-			g.setFont(TrackWidgetCommons.FREESPACE_TRACKNAME_FONT);
-			g.setColor(TrackWidgetCommons.FREESPACE_TRACKNAME_TEXT_COLOR);
+			g.setFont(SwingMiscManager.getIfUsingSwingFontManager().getInternalFont(TrackWidgetCommons.FREESPACE_TRACKNAME_FONT));
+			g.setColor(SwingConversions.toSwingColor(TrackWidgetCommons.FREESPACE_TRACKNAME_TEXT_COLOR));
 			
 			// Center track name
-			FontMetrics fm   = g.getFontMetrics(TrackWidgetCommons.FREESPACE_TRACKNAME_FONT);
+			FontMetrics fm   = g.getFontMetrics(SwingMiscManager.getIfUsingSwingFontManager().getInternalFont(TrackWidgetCommons.FREESPACE_TRACKNAME_FONT));
 			Rectangle2D rect = fm.getStringBounds(name, g);
 			
@@ -1349,9 +1344,10 @@
 
 	@Override
-	public void paint(Graphics g) {
-		super.paint(g);
+	public void paintHeavyDutyWidget(Graphics2D g)
+	{
+		super.paintHeavyDutyWidget(g);
 		
 		if (isLoaded() && nameLabel != null) {
-			nameLabel.paint(g);
+			nameLabel.paint();
 			
 			if (shouldOmitIndexAudio()) {
@@ -1360,9 +1356,13 @@
 						-20 : 0;
 				
-				IconRepository.getIcon("omitindexed.png").paintIcon(
+				/*IconRepository.getIcon("omitindexed.png").paintIcon(
 						_swingComponent, 
 						g, 
 						getX() + getWidth() - EditableSampledTrackGraphView.LOCK_ICON_CORNER_OFFSET + shiftOffset, 
-						getY() + EditableSampledTrackGraphView.LOCK_ICON_CORNER_OFFSET - 16);
+						getY() + EditableSampledTrackGraphView.LOCK_ICON_CORNER_OFFSET - 16);*/
+				
+				g.drawImage(SwingMiscManager.getIfUsingSwingImageManager().getInternalImage(IconRepository.getIcon("omitindexed.png")),
+						getX() + getWidth() - EditableSampledTrackGraphView.LOCK_ICON_CORNER_OFFSET + shiftOffset, 
+						getY() + EditableSampledTrackGraphView.LOCK_ICON_CORNER_OFFSET - 16, null);
 				
 			}
@@ -1404,5 +1404,5 @@
 						boolean inferInitTime = true;
 						
-						if (AudioFrameMouseActions.isYAxisRestictionOn()) {
+						if (ApolloGestureActions.isYAxisRestictionOn()) {
 							Mutable.Long ms = getInitiationTimeFromMeta();
 							if (ms != null) {
@@ -1417,7 +1417,8 @@
 						}
 						
-						inferInitTime &= 
-							(AudioFrameMouseActions.isMouseAnchoring() || AudioFrameMouseActions.isMouseStamping());
-
+						// Also must not set initiation time if the frame is simply being displayed
+						//inferInitTime &= (AudioFrameMouseActions.isMouseAnchoring() || AudioFrameMouseActions.isMouseStamping());
+						inferInitTime &= (eventType == ItemParentStateChangedEvent.EVENT_TYPE_ADDED);
+						
 						if (inferInitTime) 
 							initTime = Mutable.createMutableLong(FrameLayoutDaemon.getInstance().getMSAtX(getX(), parent));
@@ -1499,5 +1500,5 @@
 						MouseEventRouter.getCurrentMouseEvent().getButton() == MouseEvent.BUTTON2 &&
 						MouseEventRouter.getCurrentMouseEvent() != lastInsertME) {
-					Frame suspended = DisplayIO.getCurrentFrame();
+					Frame suspended = DisplayController.getCurrentFrame();
 					if (suspended != null) {
 						FrameLayoutDaemon.getInstance().suspendLayout(suspended, this);
@@ -1682,7 +1683,7 @@
 		
 		// Get border color currently used
-		Color oldC = getSource().getBorderColor();
-		
-		Color newC = TrackWidgetCommons.getBorderColor(
+		Colour oldC = getSource().getBorderColor();
+		
+		Colour newC = TrackWidgetCommons.getBorderColor(
 				SoundDesk.getInstance().isSolo(trackMix.getChannelID()), 
 				trackMix.isMuted());
@@ -1772,5 +1773,5 @@
 				// Build the new neighbouring widget
 				Frame target = getParentFrame();
-				if (target == null) target = DisplayIO.getCurrentFrame();
+				if (target == null) target = DisplayController.getCurrentFrame();
 				
 				// Determine init time
@@ -1811,5 +1812,5 @@
 							trackMix);
 					
-					FrameMouseActions.pickup(extractedTrack.getItems());
+					StandardGestureActions.pickup(extractedTrack.getItems());
 					
 				}
@@ -1840,5 +1841,5 @@
 						trackModel,
 						pfname,
-						_swingComponent.getBounds(),
+						SwingConversions.fromSwingRectangle(_swingComponent.getBounds()),
 						trackMix);
 
@@ -1846,5 +1847,5 @@
 
 				// Get rid of all popups
-				PopupManager.getInstance().hideAutohidePopups();
+				PopupManager.getInstance().hideAutoHidePopups();
 				
 				int start = trackModel.getSelectionStart();
@@ -1859,5 +1860,5 @@
 				ExpandedTrackManager.getInstance().expandSingleTrack(
 						trackModel, 
-						_swingComponent.getBounds(),
+						SwingConversions.fromSwingRectangle(_swingComponent.getBounds()),
 						trackMix,
 						pfname,
@@ -1882,19 +1883,16 @@
 	 *
 	 */
-	private class PlaybackPopup extends PlaybackControlPopup implements Observer {
-
-		private static final long serialVersionUID = 1L;
-		
-		public PlaybackPopup() {
+	private class PlaybackPopup extends PlaybackControlPopup implements Observer
+	{
+		public PlaybackPopup()
+		{
 			miscButton.setActionCommand("expand");
-			miscButton.setIcon(IconRepository.getIcon("expand.png"));
+			SwingMiscManager.setJButtonIcon(miscButton, IconRepository.getIcon("expand.png"));
 			miscButton.setToolTipText("Expand");
-
 		}
 
 		@Override
-		public void onHide() {
-			super.onHide();
-			
+		public void onHide()
+		{
 			// Listen for volume or mute changed events
 			trackMix.removeObserver(this);
@@ -1905,6 +1903,6 @@
 
 		@Override
-		public void onShow() {
-			super.onShow();
+		public void onShow()
+		{
 			// Listen for volume or mute changed events
 			trackMix.addObserver(this);
@@ -2016,9 +2014,11 @@
 		}
 		
-		public Subject getObservedSubject() {
+		public Subject getObservedSubject()
+		{
 			return null;
 		}
 
-		public void setObservedSubject(Subject parent) {
+		public void setObservedSubject(Subject parent)
+		{
 		}
 
@@ -2026,6 +2026,6 @@
 		 * Receives events from the track model OR from the observed track sequence.
 		 */
-		public void modelChanged(Subject source, SubjectChangedEvent event) {
-
+		public void modelChanged(Subject source, SubjectChangedEvent event)
+		{
 			// Synch GUI with track state
 			switch (event.getID()) {
@@ -2049,5 +2049,5 @@
 				stopButton.setEnabled(true);
 				rewindButton.setEnabled(false);
-				playPauseButton.setIcon(IconRepository.getIcon("pause.png"));
+				SwingMiscManager.setJButtonIcon(playPauseButton, IconRepository.getIcon("pause.png"));
 				
 				invalidateStateIcons();
@@ -2063,5 +2063,5 @@
 				rewindButton.setEnabled(true);
 				stopButton.setEnabled(false);
-				playPauseButton.setIcon(IconRepository.getIcon("play.png"));
+				SwingMiscManager.setJButtonIcon(playPauseButton, IconRepository.getIcon("play.png"));
 				
 				// Note:
@@ -2109,28 +2109,28 @@
 
 		@Override
-		protected void volumeChanged() {
+		protected void volumeChanged()
+		{
 			trackMix.setVolume(((float)volumeSlider.getValue()) / 100.0f);
 		}
 
 		@Override
-		protected void muteChanged() {
+		protected void muteChanged()
+		{
 			trackMix.setMuted(muteButton.isSelected());
 		}
 
 		@Override
-		protected void soloChanged() {
+		protected void soloChanged()
+		{
 			SoundDesk.getInstance().setSoloIDPrefix(soloButton.isSelected() ?
 					trackMix.getChannelID() : null
 					);
 		}
-		
 	}
 
 	@Override
-	public boolean isWidgetEdgeThicknessAdjustable() {
+	public boolean isWidgetEdgeThicknessAdjustable()
+	{
 		return false;
 	}
-	
-	
-	
 }
Index: /trunk/src/org/apollo/widgets/SearchRecorder.java
===================================================================
--- /trunk/src/org/apollo/widgets/SearchRecorder.java	(revision 1101)
+++ /trunk/src/org/apollo/widgets/SearchRecorder.java	(revision 1102)
@@ -30,11 +30,12 @@
 import org.apollo.util.ApolloSystemLog;
 import org.expeditee.actions.Actions;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gio.swing.SwingMiscManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.items.ItemParentStateChangedEvent;
 import org.expeditee.items.Text;
-import org.expeditee.items.widgets.InteractiveWidget;
-
-public class SearchRecorder extends InteractiveWidget 
+import org.expeditee.items.widgets.SwingWidget;
+
+public class SearchRecorder extends SwingWidget 
 	implements ActionListener, Observer {
 	
@@ -68,5 +69,5 @@
 		// Create gui layout
 		recordButton = new JButton();
-		recordButton.setIcon(IconRepository.getIcon("searchmel.png"));
+		SwingMiscManager.setJButtonIcon(recordButton, IconRepository.getIcon("searchmel.png"));
 		recordButton.setToolTipText("Search for audio from live recording");
 		recordButton.addActionListener(this);
@@ -74,5 +75,5 @@
 
 		commitButton = new JButton();
-		commitButton.setIcon(IconRepository.getIcon("commitquery.png"));
+		SwingMiscManager.setJButtonIcon(commitButton, IconRepository.getIcon("commitquery.png"));
 		commitButton.addActionListener(this);
 		commitButton.setToolTipText("GO!");
@@ -82,5 +83,5 @@
 		cancelButton = new JButton();
 		cancelButton.setToolTipText("Cancel");
-		cancelButton.setIcon(IconRepository.getIcon("cancel.png"));
+		SwingMiscManager.setJButtonIcon(cancelButton, IconRepository.getIcon("cancel.png"));
 		cancelButton.addActionListener(this);
 		cancelButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
@@ -384,5 +385,5 @@
 			if (hasExplicityStopped) {
 				
-				Frame sourceFrame = DisplayIO.getCurrentFrame();
+				Frame sourceFrame = DisplayController.getCurrentFrame();
 				
 				 if (sourceFrame != null &&
Index: /trunk/src/org/apollo/widgets/TrackWidgetCommons.java
===================================================================
--- /trunk/src/org/apollo/widgets/TrackWidgetCommons.java	(revision 1101)
+++ /trunk/src/org/apollo/widgets/TrackWidgetCommons.java	(revision 1102)
@@ -1,9 +1,12 @@
 package org.apollo.widgets;
 
-import java.awt.Color;
-import java.awt.Font;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Font;
 
 public final class TrackWidgetCommons {
-	private TrackWidgetCommons() {
+	
+	/** Static-only class. */
+	private TrackWidgetCommons()
+	{
 	}
 	
@@ -17,13 +20,13 @@
 	public static final int CACHE_DEPTH = 1;
 	
-	public static final Color FREESPACE_TRACKNAME_TEXT_COLOR = Color.WHITE;
-	public static final Font FREESPACE_TRACKNAME_FONT = new Font("Arial", Font.BOLD, 20);
+	public static final Colour FREESPACE_TRACKNAME_TEXT_COLOR = Colour.WHITE;
+	public static final Font FREESPACE_TRACKNAME_FONT = new Font("Arial", Font.Style.BOLD, 20);
 	
 	public static final int POPUP_LIFETIME = 1500;
 	
-	public static final Color STANDARD_TRACK_EDGE_COLOR = Color.BLACK;
-	public static final Color MUTED_TRACK_EDGE_COLOR = Color.GRAY;
-	public static final Color SOLO_TRACK_EDGE_COLOR = Color.RED;
-	public static final Color MUTED_SOLO_TRACK_EDGE_COLOR = new Color(255, 168, 168);
+	public static final Colour STANDARD_TRACK_EDGE_COLOR = Colour.BLACK;
+	public static final Colour MUTED_TRACK_EDGE_COLOR = Colour.GREY;
+	public static final Colour SOLO_TRACK_EDGE_COLOR = Colour.RED;
+	public static final Colour MUTED_SOLO_TRACK_EDGE_COLOR = Colour.FromRGB255(255, 168, 168);
 	
 	public static final float STOPPED_TRACK_EDGE_THICKNESS = 1.0f;
@@ -31,7 +34,7 @@
 	
 
-	public static Color getBorderColor(boolean isSolo, boolean isMuted) {
+	public static Colour getBorderColor(boolean isSolo, boolean isMuted) {
 		
-		Color newC = null;
+		Colour newC = null;
 		
 		if (isSolo && isMuted) {
